%	Tests the function PsplineDen01 at the beta density.
%	Assumes that the support, [0, 1], of the density is known.
%	PsplinedDen01 uses a logspline model and penalized estimation
%		for nonparametric density estimation
%
%	Last edit: 2/6/02

load y.dat ;
Nbins = 200 
subplot(2,1,1) ;
X = linspace(0,1,Nbins+1)' ;
X = X(2:Nbins + 1) - 1/Nbins ; 
[N ] = hist(y,X) ;
N = N' ;
set(gca,'xlim',[0 .4])
hist(y,Nbins) 

%param = struct('min_y',0,'max_y',.7,'penwt',logspace(-1,1,50),'nknots',15, ...
%	'degree',2) ;

%estden = PsplineDen01(y,param) ;
fit = PsplineDR03(X, N,struct('nknots',50,'degree',3)) ;

subplot(2,1,2) ;
mhat = max(fit.mhat,0*fit.mhat) ;

mhat = mhat / mean(mhat) ;
plot(fit.xgrid,mhat) ;

